<?php
/* XooNIps2WEKO module
 * admin/ajax.php
 * $Revision: 1.10
 */
include '../../../include/cp_header.php';

if (!defined('XOONIPS2WEKO_PATH')) {
        define('XOONIPS2WEKO_PATH', XOOPS_ROOT_PATH.'/modules/xoonips2weko');
}

$op          = "";
$t           = "";
$i           = "";
$split       = "";
$split_value = "";
$r           = "";
$w           = "";
$condition   = "";
$date        = "";
$ps          = "";
$type        = "";

if (isset($_GET['op']) && $_GET['op'] != '') {
	$op = $_GET['op'];
} else {
	exit();
}

if( $op == "export") {
	if (isset($_GET['t']) && $_GET['t'] != '') {
		$t = $_GET['t'];
	}
	if (isset($_GET['i']) && $_GET['i'] != '') {
		$i = $_GET['i'];
	}
	if (isset($_GET['s']) && $_GET['s'] != '') {
		$split = "-s ".$_GET['s'];
	}
	if (isset($_GET['m']) && $_GET['m'] != '') {
		$split = "-m ".$_GET['m'];
	}
	if (isset($_GET['r']) && $_GET['r'] != '') {
		$r = "-r";
	}
        if (isset($_GET['w']) && $_GET['w'] != '') {
                $w = "-w";
        }
        if (isset($_GET['condition_type']) && $_GET['condition_type'] != '') {
		if (isset($_GET['date']) && $_GET['date'] != '') {
			$date = $_GET['date'];
		}
                $condition_type = $_GET['condition_type'];
		if ($condition_type == "1") {
			$condition = "-o";
		} else if ($condition_type == "2") {
			$condition = "-c ".$date;
		} else if ($condition_type == "3") {
			$condition = "-u ".$date;
		} else if ($condition_type == "4") {
			$condition = "-d ".$date;
		}
        }

	$cmd = "export LANG=ja_JP.UTF-8; php ".XOONIPS2WEKO_PATH."/xoonips2weko.php";

	$f = $root->mContext->mModuleConfig['rule_file_path'];
	$cmd = $cmd.' -f "'.$f.'" ';
	$cmd = $cmd.' -t "'.$t.'" ';
	$cmd = $cmd.' -i "'.$i.'" ';
	if ( $split != "") {
		$cmd = $cmd . $split;
	}
	if ($r != "") {
		$cmd = $cmd . " " . $r;
	}
        if ($w != "") {
                $cmd = $cmd . " " . $w;
        }
        if ($condition != "") {
                $cmd = $cmd . " " . $condition;
        }
	$cmd = $cmd . " 2>&1";
	header("Content-type: text/html; charset=utf-8");
	ob_end_flush();
	ob_start('mb_output_handler');
	$hdl = popen($cmd, 'r');
	while (!feof($hdl)) {
		$log = fgets($hdl);
		if (preg_match("/\n/", $log)) {
			$log = preg_replace("/\n/", "", $log);
		}
		$log = mb_convert_encoding($log, "UTF-8", "auto");
		echo $log."\n";
		ob_flush();
		flush();
		usleep(1.1000); //0.1s
	}
	pclose($hdl);
	exit();

} else if ($op == "log") {
	if (isset($_GET['ps']) && $_GET['ps'] != '') {
		$ps = $_GET['ps'];
	}

	$rulefile = $root->mContext->mModuleConfig['rule_file_path'];
	$config = parse_ini_file($rulefile, 1);
	$logfile = $config['config']['logfile'];
	if (empty($logfile)) {
		$logfile = "/var/log/xoonips2weko.log";
	}

	$cmd = "tail -f --pid=".$ps." ".$logfile;
	header("Content-type: text/html; charset=utf-8");
	ob_end_flush();
	ob_start('mb_output_handler');
	$hdl = popen($cmd, 'r');
	while (!feof($hdl)) {
		$log = fgets($hdl);
		if (preg_match("/\n/", $log)) {
			$log = preg_replace("/\n/", "", $log);
		}
		$log = mb_convert_encoding($log, "UTF-8", "auto");
		echo $log."\n";
		ob_flush();
		flush();
		usleep(1.1000); //0.1s
	}
	pclose($hdl);
	exit();

} else if ($op == "exists") {
	if (isset($_GET['type']) && $_GET['type'] != '') {
		$type = $_GET['type'];
	}
	header("Content-type: text/plain; charset=utf8");
	if (empty($type)) {
		echo "0";
		exit();
	}

	include_once XOONIPS2WEKO_PATH . "/include/functions.php";
	$ret = find_old_files($type);
	if (empty($ret))
		echo "0";
	else
		echo "1";
	exit();

} else {
	exit();
}

