<?php
/* XooNIps2WEKO Module
 * admin/export.php
 * $Revision: 1.10
 */
include '../include/form.php';

if (!defined('XOONIPS2WEKO_PATH')) {
	define('XOONIPS2WEKO_PATH', XOOPS_ROOT_PATH.'/modules/xoonips2weko');
}

//POST
$op = "";
$t = "";
$i = "";
$r = "";
$s = "";
$split_value = "";
$split_type = "";
$export_file = "";
$condition_type = "";
$date_year = "";
$date_month = "";
$date_day = "";
$date = "";

if (isset($_POST['op']) && $_POST['op'] != '') {
	$op = $_POST{'op'};
}

if (  $op == 'export' ) {
	$exec = true;
	$err_msgs = array();
	$err_msg = "";
	if (isset($_POST['delete']) && $_POST['delete'] != '') {
		$ret = delete_old_files($_POST['delete']);
		if (!$ret) {
			$err_msg = _AD_XOONIPS2WEKO_SETTING_DELETE_ERROR;
			array_push($err_msgs, $err_msg);
			$exec = false;
		}
	}
	if (isset($_POST['item_type']) && $_POST['item_type'] != '') {
		$t = $_POST['item_type'];
	} else {
		$err_msg = _AD_XOONIPS2WEKO_SETTING_ITEM_TYPE_ERROR;
		array_push($err_msgs, $err_msg);
		$exec = false;
	}
	if (isset($_POST['index']) && $_POST['index'] != '') {
		$i = $_POST{'index'};
	} else {
		$err_msg = _AD_XOONIPS2WEKO_SETTING_INDEX_ERROR;
		array_push($err_msgs, $err_msg);
		$exec = false;
	}
	if (isset($_POST['recur']) && $_POST['recur'] != '') {
		$r = $_POST['recur'];
	} else {
		$err_msg = _AD_XOONIPS2WEKO_SETTING_RECUR_ERROR;
		array_push($err_msgs, $err_msg);
		$exec = false;
	}
	if (isset($_POST['split']) && $_POST['split'] != '') {
		$s = $_POST['split'];
	} else {
		$err_msg = _AD_XOONIPS2WEKO_SETTING_SPLIT_ERROR;
		array_push($err_msgs, $err_msg);
		$exec = false;
	}
	if ( $s == '1' ) {
		if (isset($_POST['split_value']) && $_POST['split_value'] != '') {
			$split_value = $_POST['split_value'];
			if (preg_match("/\D/", $split_value) || $split_value <= 0) {
				$err_msg = _AD_XOONIPS2WEKO_SETTING_SPLIT_VALUE_ERROR;
				array_push($err_msgs, $err_msg);
				$exec = false;
			}
		} else {
			$err_msg = _AD_XOONIPS2WEKO_SETTING_SPLIT_VALUE_ERROR;
			array_push($err_msgs, $err_msg);
			$exec = false;
		}
		if (isset($_POST['split_type']) && $_POST['split_type'] != '') {
			$split_type = $_POST['split_type'];
		} else {
			$err_msg = _AD_XOONIPS2WEKO_SETTING_SPLIT_TYPE_ERROR;
			array_push($err_msgs, $err_msg);
			$exec = false;
		}
	} else {
		//recover value
		$split_value = $_POST['split_value'];
		$split_type = $_POST['split_type'];
	}
        if (isset($_POST['export_file']) && $_POST['export_file'] != '') {
                $export_file = $_POST['export_file'];
        } else {
                $err_msg = _AD_XOONIPS2WEKO_SETTING_EXPORT_FILE_ERROR;
                array_push($err_msgs, $err_msg);
                $exec = false;
        }
	if (isset($_POST['condition_type']) && $_POST['condition_type'] != '') {
		$condition_type = $_POST['condition_type'];
	} else {
		$err_msg = _AD_XOONIPS2WEKO_SETTING_CONDITION_TYPE_ERROR;
		array_push($err_msgs, $err_msg);
		$exec = false;
	}
	if ($condition_type == "2" || $condition_type == "3" || $condition_type == "4") {
		if (isset($_POST['date_year']) && $_POST['date_year'] != '') {
			$date_year = $_POST['date_year'];
		} else {
			$err_msg = _AD_XOONIPS2WEKO_SETTING_DATE_YEAR_ERROR;
			array_push($err_msgs, $err_msg);
			$exec = false;
		}
                if (isset($_POST['date_month']) && $_POST['date_month'] != '') {
                        $date_month = $_POST['date_month'];
                } else {
                        $err_msg = _AD_XOONIPS2WEKO_SETTING_DATE_MONTH_ERROR;
                        array_push($err_msgs, $err_msg);
                        $exec = false;
                }
                if (isset($_POST['date_day']) && $_POST['date_day'] != '') {
                        $date_day = $_POST['date_day'];
                } else {
                        $err_msg = _AD_XOONIPS2WEKO_SETTING_DATE_DAY_ERROR;
                        array_push($err_msgs, $err_msg);
                        $exec = false;
                }
		if (empty($date_year) || empty($date_month) || empty($date_day)) {
			$err_msg = _AD_XOONIPS2WEKO_SETTING_DATE_ERROR;
			array_push($err_msgs, $err_msg);
			$exec = false;
		} else {
			$date = $date_year . "-" . $date_month . "-" . $date_day;
			$time = strtotime($date);
			if (empty($time)) {
                        	$err_msg = _AD_XOONIPS2WEKO_SETTING_DATE_ERROR;
                        	array_push($err_msgs, $err_msg);
                        	$exec = false;
			}
		}
	} else {
		//recover value
		$date_year = $_POST['date_year'];
		$date_month = $_POST['date_month'];
		$date_day = $_POST['date_day'];
	}

	if (!$exec) {
		$values = array(
			't'              => $t,
			'i'              => $i,
			'r'              => $r,
			's'              => $s,
			'split_value'    => $split_value,
			'split_type'     => $split_type,
			'export_file'    => $export_file,
			'condition_type' => $condition_type,
			'date_year'      => $date_year,
			'date_month'     => $date_month,
			'date_day'       => $date_day
		);
		show_setting($err_msgs, $values);
	}

	$params = array();
	$f = $root->mContext->mModuleConfig['rule_file_path'];
	$params['t'] = $t;
	$params['f'] = $f;
	$params['i'] = $i;
	$params['condition_type'] = $condition_type;
	$params['date'] = $date;
	if( $s == 1) {
		$params['split_type'] = $split_type;
		$params['split_value'] = $split_value;
	}
	if ( $r == 1 || $i == 1 ) {
		$params['r'] = $r;
	}
	if ( $export_file == 0 ) {
		$params['w'] = $export_file;
	}
	show_exec($params);
	exit();
} else {
	//ps check
	exec("ps axT|grep \"php .*xoonips2weko.php\"|grep -v grep|grep -v sudo|grep -v \"sh -c\"", $output, $result);
	if (count($output) >= 1) {
		foreach ($output as $out) {
			 preg_match("/^\s*([0-9]+)\s/", $out, $matches);
			break;
		}
		$ps = $matches[1];
		//ログを表示する
		show_log($ps);
	} else {
		//エクスポート設定画面の表示
		show_setting();
	}
}

exit();

