<?php
/* XooNIps2WEKO Module
 * include/form.php
 * $Revision: 1.10
 */
include_once '../../../include/cp_header.php';

//XooNIps
include_once XOOPS_ROOT_PATH.'/modules/xoonips/include/AL.php';
include_once XOOPS_ROOT_PATH.'/modules/xoonips/include/common.inc.php';
include_once XOOPS_ROOT_PATH.'/modules/xoonips/include/gentree.php';

if (!defined('XOONIPS2WEKO_PATH')) {
        define('XOONIPS2WEKO_PATH', XOOPS_ROOT_PATH.'/modules/xoonips2weko');
}

include_once XOONIPS2WEKO_PATH.'/include/functions.php';

function auto_scroll()
{
echo <<<EOF
<script type="text/javascript">
function auto_scroll() {
	var textArea =  document.getElementById('output_log');
	if ( textArea.createTextRange) {
		var range = textArea.createTextRange();
		range.move('character', textArea.value.length);
		range.select();
	} else if(textArea.setSelectionRange) {
		textArea.setSelectionRange(textArea.value.length, textArea.value.length);
	}
}
</script>
EOF;
}

function do_ajax($url)
{
auto_scroll();
echo <<<EOF
<script type="text/javascript">
function do_ajax() {
	var request = new XMLHttpRequest;
        request.onreadystatechange = function() {
		if ( request.readyState >= 3 && request.status == 200) {
			try {
				var lines = request.responseText.split("\\n");
				output_log  = document.getElementById('output_log').innerHTML;
				var logs = output_log.split("\\n");
				if (logs != null) {
					d = lines.length - logs.length;
					// lines last index is null
					for (var i=lines.length-d-1; i<lines.length-1; i++) {
						if (lines[i] != null) {
							document.getElementById('output_log').innerHTML += lines[i] + "\\n";
						}
					}
				} else {
                			document.getElementById('output_log').innerHTML = request.responseText;
				}
			} catch (e) {
				//not support readyState 3 old I.E
			}
		}
		auto_scroll();
	};
	request.open("GET", "${url}");
	request.send(null);
}
</script>
EOF;
echo '<script type="text/javascript">do_ajax()</script>';
}

function ajax_exec($params)
{

	$url = XOOPS_URL.'/modules/xoonips2weko/admin/ajax.php';
	$param = "";
	$param = "?op=export";
	if (isset($params['t'])) {
		$param = $param."&t=".$params['t'];
	}
	if (isset($params['i'])) {
		$param = $param."&i=".$params['i'];
	}
	if (isset($params['split_type']) && isset($params['split_value'])) {
		$param = $param."&".$params['split_type']."=".$params['split_value'];
	}
	if (isset($params['r'])) {
		$param = $param."&r=1";
	}
        if (isset($params['w'])) {
                $param = $param."&w=1";
        }
	if (isset($params['condition_type'])) {
		$param = $param."&condition_type=".$params['condition_type'];
		if ($params['condition_type'] == "2" || $params['condition_type'] == "3" || $params['condition_type'] == "4") {
			$param = $param."&date=".$params['date'];
		}
	}
	$url = $url . $param;
	do_ajax($url);
}

function ajax_log($ps)
{

	$url = XOOPS_URL.'/modules/xoonips2weko/admin/ajax.php';
	$param = "";
	$param = "?op=log";
	$param = $param."&ps=".$ps;
	$url = $url . $param;
	do_ajax($url);
}

function get_index_select(&$indexes)
{
	$select = array();
	foreach( $indexes as $i => $index ) {
		$key = $index['item_id'];
		// tree nodes
		$option = array();
		$option['index_id'] = $key;
		$option['title'] = "/".$index['html_title'];
		if ($index['parent_index_id'] == "1") {
			$option['parent'] = null;
		} else {
			$option['parent'] = $index['parent_index_id'];
		}
		$select[$key] = $option;

	}
	foreach ( $select as $index_id => $value) {
		if ($value['parent'] != null ) {
			$index_title = $select[$value['parent']]['title'].$value['title'];
			$select[$index_id]['title'] = $index_title;
		}
	}
	return $select;
}

function show_setting($error=false, $values=false)
{
	$xnpsid = $_SESSION['XNPSID'];
	$indexes = genIndexTree0( $xnpsid );
	$indexes = genIndexTree1( $indexes );
	$indexes = get_index_select( $indexes );
	$types = get_all_item_type();

        $style = "text-align:left; vertical-align:top;";
        xoops_cp_header();

	foreach (glob("/tmp/xoonips_*.tar.gz") as $file) {
		echo '<font color="red"> Warning! Export Item exists '. $file .'</font><br>'."\n";
	}

	$url = XOOPS_URL.'/modules/xoonips2weko/admin/ajax.php?op=exists&type=';
	$msg1 = _AD_XOONIPS2WEKO_SETTING_CONFIRM;
	echo <<<EOF
<script type="text/javascript">
function do_find_old_files(form) {
	var index = form.item_type.selectedIndex;
	var type_sum = form.item_type.options[index].text.split(" ");
	var type = type_sum[0];
	var url = "$url" + type;
	var msg = "\"" + type + "\" $msg1";
	var request = new XMLHttpRequest;
	request.open("GET", url, false);
	request.send(null);

	if (request.responseText === "0") {
		return true;
	} else {
		if (window.confirm(msg)) {
			var del = document.createElement("input");
			del.setAttribute("name", "delete");
			del.setAttribute("type", "hidden");
			del.setAttribute("value", type);
			form.appendChild(del);
			return true;
		} else {
			return false;
		}
	}
}
function split_on(status) {
	row = document.getElementById("split_type_row");
	if (status == true) {
		row.style.display = "";
	} else {
		row.style.display = "none";
	}
	return false;
}
function condition_type_change(obj) {
	value = obj.options[obj.selectedIndex].value;
	row = document.getElementById("date_row");
	if (value > 1) {
		row.style.display = "";
	} else {
		row.style.display = "none";
	}
	return false;
}
</script>
EOF;
        if (isset($error)) {
                if (is_array($error)) {
                        foreach ( $error as $msg ) {
                                echo "<font color=\"red\">".$msg."</font><br>\n";
                        }
                } else {
                        echo '<font color="red">'.$error.'</font><br>'."\n";
                }
        }
        echo "<h3>"._AD_XOONIPS2WEKO_SHOW_SETTING_TITLE."</h3>";
	echo '<div style="color: blue; margin: 10px;">';
	echo _AD_XOONIPS2WEKO_SHOW_SETTING_DESC;
	echo '</div>';
        echo '<form id="export_setting" method="post" action="export.php" onsubmit="return do_find_old_files(this)">';
        echo '<table class="outer" cellspacing="1" style="width:100%;">';
        echo '<tbody>';
        echo '<tr><th colspan="2">'._AD_XOONIPS2WEKO_SETTING_FORM.'</th></tr>';
	//item type
	echo '<tr>';
	echo '<td class="head" style="'.$style.'">';
	echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
	echo _AD_XOONIPS2WEKO_SETTING_ITEM_TYPE;
	echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
	echo _AD_XOONIPS2WEKO_SETTING_ITEM_TYPE_DESC;
	echo '</p>';
	echo '</div>';
	echo '</td>';
	echo '<td class="even" style="'.$style.'">';
	echo '<select name="item_type">';
	foreach ($types as $type) {
		echo '<option value='.$type['item_type_id'];
		if ($type['item_type_id'] == $values['t'])
			echo ' selected';
		echo '>'.$type['display_name'].'</option>';
	}
	echo '</select>';
	echo '</td>';
	echo '</tr>';
        //index
        echo '<tr>';
        echo '<td class="head" style="'.$style.'">';
	echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
	echo _AD_XOONIPS2WEKO_SETTING_INDEX;
	echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
	echo _AD_XOONIPS2WEKO_SETTING_INDEX_DESC;
	echo '</p>';
	echo '</div>';
	echo '</td>';
	echo '<td class="even" style="'.$style.'">';
	echo '<select name="index">';
	echo '<option value="1"';
	if ( !isset($values['i']) || $values['i'] == '1') {
		echo ' selected ';
	}
	echo '>'._AD_XOONIPS2WEKO_SETTING_INDEX_ROOT.'</option>';
	foreach ($indexes as $index) {
		echo '<option value='.$index['index_id'];
		if ($index['index_id'] == $values['i'] ) {
			 echo ' selected ';
		}
		echo '>'.$index['title'].'</option>';
	}
	echo '</select>';
	echo '</td>';
        echo '</tr>';
        //recur
        echo '<tr>';
        echo '<td class="head" style="'.$style.'">';
	echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
	echo _AD_XOONIPS2WEKO_SETTING_RECUR;
	/*
	echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
	echo _AD_XOONIPS2WEKO_SETTING_RECUR_DESC;
	echo '</p>';
	*/
	echo '</div>';
	echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<input id="xoonips2weko_setting_recur1" type="radio"';
        if ( !isset($values['r']) || $values['r'] == 1) {
                echo '" checked="checked "';
        }
        echo 'value="1" name="recur">';
        echo '<label for="xoonips2weko_setting_recur1">'._AD_XOONIPS2WEKO_SETTING_YES.'</label>';
        echo '<input id="xoonips2weko_setting_recur0" type="radio"';
        if ( $values['r'] == 0) {
                echo '" checked="checked "';
        }
        echo 'value="0" name="recur">';
        echo '<label for="xoonips2weko_setting_recur0">'._AD_XOONIPS2WEKO_SETTING_NO.'</label>';
        echo '</td>';
        echo '</tr>';
        //split
        echo '<tr>';
        echo '<td class="head" style="'.$style.'">';
	echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
	echo _AD_XOONIPS2WEKO_SETTING_SPLIT;
	/*
	echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
	echo _AD_XOONIPS2WEKO_SETTING_SPLIT_DESC;
	echo '</p>';
	*/
	echo '</div>';
	echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<input id="xoonips2weko_setting_split1" type="radio"';
        if ( !isset($values['s']) || $values['s'] == 1 ) {
                echo '" checked="checked "';
        }
        echo 'value="1" name="split" onclick="split_on(true)">';
        echo '<label for="xoonips2weko_setting_split1">'._AD_XOONIPS2WEKO_SETTING_YES.'</label>';
        echo '<input id="xoonips2weko_setting_split0" type="radio"';
        if ( $values['s'] == 0 ) {
                echo '" checked="checked "';
        }
        echo 'value="0" name="split" onclick="split_on(false)">';
        echo '<label for="xoonips2weko_setting_split0">'._AD_XOONIPS2WEKO_SETTING_NO.'</label>';
        echo '</td>';
        echo '</tr>';
        //split type
        echo '<tr id="split_type_row" style="';
        if ( $values['s'] == 0 ) {
                echo 'display: none';
	}
	echo '">';
        echo '<td class="head" style="'.$style.'">';
	echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
	echo _AD_XOONIPS2WEKO_SETTING_SPLIT_TYPE;
	echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
	echo _AD_XOONIPS2WEKO_SETTING_SPLIT_TYPE_DESC;
	echo '</p>';
	echo '</div>';
	echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<input type="text" name="split_value" size="50" value="'.$values['split_value'].'">';
        echo '<select name="split_type">';
        echo '<option value="s"';
        if ( !isset($values['split_type']) || $values['split_type'] == 's' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_SPLIT_TYPE_S.'</option>';
        echo '<option value="m"';
        if ( $values['split_type'] == 'm') {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_SPLIT_TYPE_M.'</option>';
        echo '</select>';
        echo '</td>';
        echo '</tr>';
	//export file
        echo '<tr>';
        echo '<td class="head" style="'.$style.'">';
        echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
        echo _AD_XOONIPS2WEKO_SETTING_EXPORT_FILE;
        echo '</div>';
        echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<input id="xoonips2weko_setting_export_file1" type="radio"';
        if ( !isset($values['export_file']) || $values['export_file'] == 1) {
                echo '" checked="checked "';
        }
        echo 'value="1" name="export_file">';
        echo '<label for="xoonips2weko_setting_export_file11">'._AD_XOONIPS2WEKO_SETTING_YES.'</label>';
        echo '<input id="xoonips2weko_setting_export_file10" type="radio"';
        if ( $values['export_file'] == 0) {
                echo '" checked="checked "';
        }
        echo 'value="0" name="export_file">';
        echo '<label for="xoonips2weko_setting_export_file10">'._AD_XOONIPS2WEKO_SETTING_NO.'</label>';
        echo '</td>';
        echo '</tr>';
	//condition
        echo '<tr>';
        echo '<td class="head" style="'.$style.'">';
        echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
        echo _AD_XOONIPS2WEKO_SETTING_CONDITION;
        echo '<p style="text-align:left;padding-left:5px;font-weight:normal;">';
        echo _AD_XOONIPS2WEKO_SETTING_CONDITION_DESC;
        echo '</p>';
        echo '</div>';
        echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<select name="condition_type" onchange="condition_type_change(this)" >';
        echo '<option value="0"';
        if ( !isset($values['condition_type']) || $values['condition_type'] == '0' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_CONDITION_NO.'</option>';
        echo '<option value="1"';
        if ( $values['condition_type'] == '1' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_CONDITION_ONLY_DELETE_ITMES.'</option>';
        echo '<option value="2"';
        if ( $values['condition_type'] == '2' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_CONDITION_CREATE_DATE.'</option>';
        echo '<option value="3"';
        if ( $values['condition_type'] == '3' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_CONDITION_UPDATE_DATE.'</option>';
        echo '<option value="4"';
        if ( $values['condition_type'] == '4' ) {
                echo ' selected ';
        }
        echo '>'._AD_XOONIPS2WEKO_SETTING_CONDITION_DELETE_DATE.'</option>';
        echo '</select>';
        echo '</td>';
        echo '</tr>';
	//date
        echo '<tr id="date_row" style="';
	if ( !isset($values['condition_type']) || $values['condition_type'] == '0' || $values['condition_type'] == '1' ) {
		echo 'display: none';
	}
	echo '">';
        echo '<td class="head" style="'.$style.'">';
        echo '<div style="text-align:left;padding-left:5px;font-weight:bold;">';
        echo _AD_XOONIPS2WEKO_SETTING_DATE;
        echo '</div>';
        echo '</td>';
        echo '<td class="even" style="'.$style.'">';
        echo _AD_XOONIPS2WEKO_SETTING_DATE_YEAR;
        echo '<input type="text" name="date_year" size="4" maxlength="4" value="'.$values['date_year'].'">';
        echo _AD_XOONIPS2WEKO_SETTING_DATE_MONTH;
        echo '<input type="text" name="date_month" size="2" maxlength="2" value="'.$values['date_month'].'">';
        echo _AD_XOONIPS2WEKO_SETTING_DATE_DAY;
        echo '<input type="text" name="date_day" size="2" maxlength="2" value="'.$values['date_day'].'">';
        echo '</td>';
        echo '</tr>';
        //submit
        echo '<tr>';
        echo '<td class="head" style="'.$style.'"></td>';
        echo '<td class="even" style="'.$style.'">';
        echo '<input type="submit" value="'._AD_XOONIPS2WEKO_SETTING_SUBMIT.'" name="submit">';
        echo '</td>';
        echo '</tr>';
        echo '</tbody>';
        echo '</table>';
        echo '<input type="hidden" name="op" value="export">';
        echo '</form>';
        xoops_cp_footer();
        exit();
}

function show_exec($params)
{
        if($params == '') {
                show_setting("EXPORT ERROR");
        }
        xoops_cp_header();
        ob_end_flush();
        ob_start('mb_output_handler');
        echo "<h3>"._AD_XOONIPS2WEKO_SHOW_EXEC_TITLE."</h3>";
        echo '<form name="form"><textarea rows="30" cols="120" name="output_log" id="output_log" readonly></textarea></form>';
	ajax_exec($params);
        xoops_cp_footer();
        exit();
}

function show_log($ps)
{
        xoops_cp_header();
        ob_end_flush();
        ob_start('mb_output_handler');
        echo "<h3>"._AD_XOONIPS2WEKO_SHOW_LOG_TITLE."</h3>";
        echo '<form name="form"><textarea rows="30" cols="120" name="output_log" id="output_log"></textarea></form>';
        ajax_log($ps);
        xoops_cp_footer();
        exit();
}

